require "import"
import "com.androlua.*"
import "android.content.*"
import "android.net.*"
import "java.text.SimpleDateFormat"
import "java.util.Date"
import "android.app.*"
import "android.widget.*"
import "android.view.*"

-- Create a layout with an EditText, buttons, and a message
local layout = LinearLayout(this)
layout.setOrientation(LinearLayout.VERTICAL)

local titleText = TextView(this)

layout.addView(titleText)

local editText = EditText(this)
editText.setContentDescription("Link input field")
layout.addView(editText)

local clearButton = Button(this)
clearButton.setText("Clear")
layout.addView(clearButton)

local pasteButton = Button(this)
pasteButton.setText("Paste valid link")
layout.addView(pasteButton)

local messageText = TextView(this)
layout.addView(messageText)

local downloadButton = Button(this)
require("button")(titleText, editText, clearButton, pasteButton, messageText, downloadButton)
downloadButton.setContentDescription("Download Button")
layout.addView(downloadButton)

-- Define the URL and click listener for the download button
local url = ""
editText.setText(url)  -- Set the initial URL

clearButton.setOnClickListener(View.OnClickListener {
    onClick = function(view)
        editText.setText("")  -- Clear the EditText
    end
})

pasteButton.setOnClickListener(View.OnClickListener {
    onClick = function(view)
        local clipboard = activity.getSystemService(Context.CLIPBOARD_SERVICE)
        local clipData = clipboard.getPrimaryClip()
        if clipData ~= nil and clipData.getItemCount() > 0 then
            local pasteText = clipData.getItemAt(0).getText()
            editText.setText(pasteText)
        end
    end
})

downloadButton.setOnClickListener(View.OnClickListener {
    onClick = function(view)
        local enteredUrl = editText.getText().toString()
        if enteredUrl == "" then
            -- Ask the user to enter a URL if it's empty
Toast.makeText(this, "Please enter the video link", Toast.LENGTH_SHORT).show()
        else
            -- Check if a video format is chosen (you can add your logic here)
            -- If not chosen, display a message and prevent downloading.
            if isVideoFormatChosen() then
                Http.get(enteredUrl, function(status, data)
                    if status == 200 then
                        -- Create an intent to download the video file
                        local intent = Intent()
                        intent.setAction(Intent.ACTION_VIEW)
                        intent.setData(Uri.parse("https://down.app/#url=" .. enteredUrl))
                        this.startActivity(intent)
                    else
                        -- Handle error or show a message to the user
Toast.makeText(this, "Loading failed.", Toast.LENGTH_SHORT).show()
                    end
                end)
            else
                -- Display a message that a format must be chosen
Toast.makeText(this, "Please choose the video format first.", Toast.LENGTH_SHORT).show()
            end
        end
    end
})

-- Set the layout for the activity
activity.setContentView(layout)

-- Add your logic to check if a video format is chosen
function isVideoFormatChosen()
    -- Add your logic here to check if a video format is chosen
    -- Return true if a format is chosen, otherwise return false
    return true  -- Modify this to your actual logic
end